/* Problem URL: https://codeforces.com/problemset/problem/514/C */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    ll mod = (1LL << 61) - 1;
    mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
    ll b = uniform_int_distribution<ll>(1, mod - 1)(rng);

    unordered_set<ll> act;

    auto gethash = [=](const string &a){
        ll hash = 0;

        repv(i, a) {
            hash = ((__int128)hash * b + i) % mod;
        }

        return hash;
    };

    vl sufhash;
    vl pow = {1};

    function<void(string&, ll, int, bool)> add = [&](string &a, ll hash, int i, bool diff) {
        if (i >= a.size()) {
            if (diff) {
                act.insert(hash);
            }
            return;
        }

        if (diff) {
            hash = ((__int128)hash * pow[a.size() - i] + sufhash[i]) % mod;
            act.insert(hash);
            return;
        }

        for (char j = 'a'; j <= 'c'; j++) {
            add(a, ((__int128)hash * b + j) % mod, i + 1, j != a[i]);
        }
    };

    while (n--) {
        string a;
        cin >> a;

        while (pow.size() <= a.size()) {
            pow.push_back(((__int128)pow.back() * b) % mod);
        }

        sufhash.resize(a.size());
        ll hash = 0;
        for (int i = a.size() - 1; i >= 0; i--) {
            hash = ((__int128)a[i] * pow[a.size() - i - 1] + hash) % mod;
            sufhash[i] = hash;
        }

        add(a, 0, 0, false);
    }

    while (m--) {
        string a;
        cin >> a;

        ll hash = gethash(a);
        if (act.find(hash) == act.end()) {
            cout << "NO\n";
        } else {
            cout << "YES\n";
        }
    }
}
